Checking affected topic namespaces before history rewrites
==========================================================

  $ . "$TESTDIR/testlib/common.sh"

  $ cat >> $HGRCPATH << EOF
  > [extensions]
  > evolve =
  > topic =
  > rebase =
  > histedit =
  > [phases]
  > publish = no
  > [experimental]
  > tns-allow-rewrite =
  > EOF

  $ hg init repo
  $ cd repo

Make sure general checks in precheck() happen before topic namespaces checks

  $ hg prune null
  abort: cannot prune null changeset
  (no changeset checked out)
  [255]

  $ echo apple > a
  $ hg ci -qAm apple

  $ hg debug-topic-namespace foo
  marked working directory as topic namespace: foo
  $ hg topic bar
  marked working directory as topic: bar
  $ echo banana > b
  $ hg ci -qAm 'banana'

Allowing topic namespaces with --config works correctly

  $ echo broccoli > b
  $ hg amend -m 'broccoli'
  abort: refusing to amend changesets with these topic namespaces: foo
  (modify experimental.tns-allow-rewrite to allow rewriting changesets from these topic namespaces)
  [255]
  $ hg amend -m 'broccoli' --config experimental.tns-allow-rewrite=foo,something-unrelated

  $ echo coconut > b
  $ hg ci -qAm 'coconut'

Testing history-rewriting commands from evolve extension

  $ hg amend -m 'coconut'
  abort: refusing to amend changesets with these topic namespaces: foo
  (modify experimental.tns-allow-rewrite to allow rewriting changesets from these topic namespaces)
  [255]
  $ hg amend --patch -m 'coconut'
  abort: refusing to amend changesets with these topic namespaces: foo
  (modify experimental.tns-allow-rewrite to allow rewriting changesets from these topic namespaces)
  [255]
  $ hg uncommit
  abort: refusing to uncommit changesets with these topic namespaces: foo
  (modify experimental.tns-allow-rewrite to allow rewriting changesets from these topic namespaces)
  [255]
  $ hg prune -r .
  abort: refusing to prune changesets with these topic namespaces: foo
  (modify experimental.tns-allow-rewrite to allow rewriting changesets from these topic namespaces)
  [255]
  $ hg split -r .
  abort: refusing to split changesets with these topic namespaces: foo
  (modify experimental.tns-allow-rewrite to allow rewriting changesets from these topic namespaces)
  [255]
  $ hg touch -r .
  abort: refusing to touch changesets with these topic namespaces: foo
  (modify experimental.tns-allow-rewrite to allow rewriting changesets from these topic namespaces)
  [255]

Testing core history-rewriting commands

  $ hg ci --amend
  abort: refusing to amend changesets with these topic namespaces: foo
  (modify experimental.tns-allow-rewrite to allow rewriting changesets from these topic namespaces)
  [255]
  $ hg branch different-branch --rev .
  abort: refusing to change branch of changesets with these topic namespaces: foo
  (modify experimental.tns-allow-rewrite to allow rewriting changesets from these topic namespaces)
  [255]

  $ cd ..
